import { Component, OnInit } from '@angular/core';
import { MarkdownService } from '../markdown.service';
import { WebSocketService } from '../websocket.service';

class Message {
  originator: string;
  timestamp: Date;
  message: string;
}

@Component({
  selector: 'app-logs',
  templateUrl: './logs.component.html',
  styleUrls: ['./logs.component.scss']
})
export class LogsComponent implements OnInit {
  messages: Message[] = [];
  constructor(
    private markdownService: MarkdownService,
    private websocketService: WebSocketService
  ) {}

  convert(text: string) {
    return this.markdownService.convertToHtml(text);
  }

  ngOnInit() {
    this.websocketService.observeAnchor<Message>('message').subscribe(
      (event) => {
        this.messages.push(event.data);
        event.data.message = this.convert(event.data.message);
      }
    );
  }

}
